//EDefine.h

#ifndef _XDEFINE_H
#define _XDEFINE_H

#include <d3d9.h>
#include <d3dx9.h>
#include <vector>
#include "../xmlnode/StringUtil.h"

typedef std::vector<int>	IntVector;
typedef std::vector<float>  FloatVector;

struct StaticVertex
{
	enum { FVF = (D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1) };
	D3DXVECTOR3	p;
	D3DXVECTOR3	n;
	D3DXVECTOR2	t;
};

struct  VertexInfo
{
	VertexInfo()
	{
		p.Set( 0, 0 , 0 );
		n.Set( 0, 0, 0 );
		t.Set( 0, 0 );	
		index = 0;
	}

	int				index;      //   ؽ  
	base::Vector3	p;			// pos
	base::Vector3	n;			// normal
	base::Vector2	t;			// texture coord
	FloatVector		boneWeight;	// blend weight
	IntVector		boneIndex;	// blend index
};


template<typename T>
void stl_wipe_vector( std::vector<T>& rVector )
{
	std::vector<T> emptyData;
	rVector.swap( emptyData );
}

struct AnimationInfo
{
	int		beginFrame, endFrame, fps;
	int		tickPerFrame;

	AnimationInfo()
	{
		beginFrame = endFrame = fps = tickPerFrame = 0;
	}
};


#endif